% Load pb from file and convert back to original format.
function pb = pb_load(filename)
   % rescaling for pb channels
   maxval = 64;         % maximum absolute value of any component channel
   maxint = 2.^15-1;    % maximum integer
   % load file
   data = load(filename,'pb');
   % convert components to double precision format
   pb.bg1  = double(data.pb.bg1)./maxint.*maxval;
   pb.bg2  = double(data.pb.bg2)./maxint.*maxval;
   pb.bg3  = double(data.pb.bg3)./maxint.*maxval;
   pb.cga1 = double(data.pb.cga1)./maxint.*maxval;
   pb.cga2 = double(data.pb.cga2)./maxint.*maxval;
   pb.cga3 = double(data.pb.cga3)./maxint.*maxval;
   pb.cgb1 = double(data.pb.cgb1)./maxint.*maxval;
   pb.cgb2 = double(data.pb.cgb2)./maxint.*maxval;
   pb.cgb3 = double(data.pb.cgb3)./maxint.*maxval;
   pb.tg1  = double(data.pb.tg1)./maxint.*maxval;
   pb.tg2  = double(data.pb.tg2)./maxint.*maxval;
   pb.tg3  = double(data.pb.tg3)./maxint.*maxval;
   % convert textons to double precision format
   pb.textons = double(data.pb.textons);
end
