% Save pb in a space-efficient format.
function pb_save(pb, filename);
   % rescaling for pb channels
   maxval = 64;         % maximum absolute value of any component channel
   maxint = 2.^15-1;    % maximum integer
   % convert components to int16 format
   pb.bg1  = int16(pb.bg1./maxval.*maxint);
   pb.bg2  = int16(pb.bg2./maxval.*maxint);
   pb.bg3  = int16(pb.bg3./maxval.*maxint);
   pb.cga1 = int16(pb.cga1./maxval.*maxint);
   pb.cga2 = int16(pb.cga2./maxval.*maxint);
   pb.cga3 = int16(pb.cga3./maxval.*maxint);
   pb.cgb1 = int16(pb.cgb1./maxval.*maxint);
   pb.cgb2 = int16(pb.cgb2./maxval.*maxint);
   pb.cgb3 = int16(pb.cgb3./maxval.*maxint);
   pb.tg1  = int16(pb.tg1./maxval.*maxint);
   pb.tg2  = int16(pb.tg2./maxval.*maxint);
   pb.tg3  = int16(pb.tg3./maxval.*maxint);
   % convert textons to uint8 format
   pb.textons = uint8(pb.textons);
   % save in specified file
   save(filename,'pb');
end
