% Return the image averaged over the segments defined by the UCM.
% Each segment is colored by the average of its member image pixels.
function im_seg = segment_im(im, ucm)
   % extract segment information from ucm
   S = segment_ucm(ucm);
   % initialize average segment image
   [sx sy sz] = size(im);
   im_seg = zeros([sx sy sz]);
   % average colors in each segment
   for ch = 1:sz
      im_ch     = im(:,:,ch);
      im_ch_avg = zeros([sx sy]);
      for n = 1:S.n_regions
         px = S.seg_members{n};
         im_ch_avg(px) = mean(im_ch(px));
      end
      im_seg(:,:,ch) = im_ch_avg;
   end
end
