%dir_im = '/mnt/remote/users/mmaire/visionfiler/common/mmaire/pascal_voc/VOCdevkit/VOC2010/JPEGImages/';
%dir_gt = '/mnt/remote/users/mmaire/visionfiler/common/mmaire/pascal_voc/VOCdevkit/VOC2010/SegmentationClass/';
%dir_scene = '/mnt/remote/users/mmaire/visionfiler/scratch/mmaire/voc_res/results_rc_4/scene/';

dir_im = '/home/mmaire/vocdata/JPEGImages/';
dir_gt = '/home/mmaire/vocdata/SegmentationClass/';
dir_scene = '/home/mmaire/vocdata/scene/';

names = dir([dir_scene '*.mat']); names = {names.name};
for n = 1:numel(names), name = names{n}; names{n} = name(1:end-10); end

% allocate feature arrays
n_imgs = numel(names);
f_mx_arr     = cell([n_imgs 1]);
has_det_arr  = cell([n_imgs 1]);
gt_label_arr = cell([n_imgs 1]);
weights_arr  = cell([n_imgs 1]);

% compute features for each image
%for n = 1:n_imgs
for n = (floor(n_imgs./2)+1):n_imgs
   disp(['compute features for image ' num2str(n) ' of ' num2str(n_imgs)]);
   % load data
   name = names{n};
   im    = double(imread([dir_im name '.jpg']))./255;
   im_gt = double(imread([dir_gt name '.png']));
   scene = load([dir_scene name '-scene.mat']);
   scene = scene.scene;
   % compute features
   [sdata sfeat]       = seg_features(scene, im, im_gt);
   [f_mx has_det]      = seg_feature_mx(sfeat);
   [gt_labels weights] = seg_feature_gt(sfeat);
   % store features
   gt_label_arr{n} = gt_labels;
   has_det_arr{n}  = has_det;
   f_mx_arr{n}     = f_mx;
   weights_arr{n}  = weights;
end

% concatenate training examples
f_mx_all      = cell2mat(f_mx_arr((floor(n_imgs./2)+1):n_imgs));
has_det_all   = cell2mat(has_det_arr((floor(n_imgs./2)+1):n_imgs));
gt_labels_all = cell2mat(gt_label_arr((floor(n_imgs./2)+1):n_imgs));
weights_all   = cell2mat(weights_arr((floor(n_imgs./2)+1):n_imgs));

% select examples for which there is an associated detection
train_inds = find(has_det_all);

gt_labels_tr = gt_labels_all(train_inds);
f_mx_tr      = f_mx_all(train_inds,:);
weights_tr   = weights_all(train_inds);

% equalize positive/negative example weight
%gt_labels_tr = round(gt_labels_tr);
%e_pos = find(gt_labels_tr == 1);
%e_neg = find(gt_labels_tr == 0);
%w_pos_tot = sum(weights_tr(e_pos));
%w_neg_tot = sum(weights_tr(e_neg));
%weights_tr(e_pos) = weights_tr(e_pos)./w_pos_tot;
%weights_tr(e_neg) = weights_tr(e_neg)./w_neg_tot;

% train classifier
[beta,p,lli]  = logist2(gt_labels_tr, f_mx_tr, weights_tr);

% show predictions
%for n = 1:n_imgs
for n = 1:floor(n_imgs./2)
   disp(['results for image ' num2str(n) ' of ' num2str(n_imgs)]);
   % load data
   name = names{n};
   im    = double(imread([dir_im name '.jpg']))./255;
   im_gt = double(imread([dir_gt name '.png']));
   scene = load([dir_scene name '-scene.mat']);
   scene = scene.scene;
   % compute features
   [sdata sfeat]  = seg_features(scene, im);
   [f_mx has_det] = seg_feature_mx(sfeat);
   % predict foreground probability
   pred    = 1./(1 + exp(-f_mx*beta));
   pred_th = (pred > 0.35).*(has_det);
   % display prediction
   figure(1); imagesc(im); title('image'); axis('image');
   figure(2); imagesc(scene.fg.fg_pixels); title('figure/ground'); axis('image'); colorbar;
   figure(3); imagesc(pred(sdata.seg_arr{1}.seg)); title('predicted figure/ground'); axis('image'); colorbar; caxis([0 1]);
   figure(4); imagesc(pred_th(sdata.seg_arr{1}.seg)); title('predicted figure/ground'); axis('image'); colorbar; caxis([0 1]);
   figure(5); imagesc(im_gt == 15); title('groundtruth'); axis('image');
   pause;
end
