% Extract groundtruth segment foreground probabilities.
%
% [gt_labels weights] = seg_feature_gt(sfeat)
%
% Input:
%    sfeat        - features for each segment
%
% Output:
%    gt_labels    - groundtruth foreground probabilities
%    weights      - importance weighting on each example
function [gt_labels weights] = seg_feature_gt(sfeat)
   gt_labels = sfeat.gt_overlap;
   weights   = (sfeat.f.seg_size(:,1));
end
