% Compute and return components of multiscale pb.
%
% pb = compute_pb(im)
%
% Input:
%    im   - image
%
% Output:
%    pb   - multiscale pb components
function pb = pb_compute(im)
   % compute cues
   [mPb_nmax mPb_nmax_rsz ...
    bg1  bg2  bg3 ...
    cga1 cga2 cga3 ...
    cgb1 cgb2 cgb3 ...
    tg1  tg2  tg3 textons] = multiscalePb(im, 1.0);
   % store components in structure
   pb.bg1  = bg1;
   pb.bg2  = bg2;
   pb.bg3  = bg3;
   pb.cga1 = cga1;
   pb.cga2 = cga2;
   pb.cga3 = cga3;
   pb.cgb1 = cgb1;
   pb.cgb2 = cgb2;
   pb.cgb3 = cgb3;
   pb.tg1  = tg1;
   pb.tg2  = tg2;
   pb.tg3  = tg3;
   % store textons
   pb.textons = textons;
end
